import .connectives
import .leibniz
import .logic
axiom bool.bool : Type.
constant bool.true : bool.bool.
constant bool.false : bool.bool.
axiom bool.match_bool_prop : forall (return:(bool.bool) -> Prop) , ((return) ((bool.true) )) -> ((return) ((bool.false) )) -> forall (z:bool.bool) , (return) (z).
constant bool.match_bool_type : forall (return : Type) , (return) -> (return) -> (bool.bool) -> return.
axiom bool.axiom_match_bool_type_true : forall (return : Type) , forall (case_true:return) , forall (case_false:return) , (((connectives.equal) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.true) ))) (case_true).
theorem bool.eq_match_bool_type_true : forall (return : Type) , forall (case_true:return) , forall (case_false:return) , (((leibniz.leibniz) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.true) ))) (case_true) := fun (return : Type) , fun (case_true : return) , fun (case_false : return) , ((((@connectives.equal_leibniz) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.true) ))) (case_true)) ((((@bool.axiom_match_bool_type_true) (return)) (case_true)) (case_false)).
axiom bool.axiom_match_bool_type_false : forall (return : Type) , forall (case_true:return) , forall (case_false:return) , (((connectives.equal) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.false) ))) (case_false).
theorem bool.eq_match_bool_type_false : forall (return : Type) , forall (case_true:return) , forall (case_false:return) , (((leibniz.leibniz) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.false) ))) (case_false) := fun (return : Type) , fun (case_true : return) , fun (case_false : return) , ((((@connectives.equal_leibniz) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.false) ))) (case_false)) ((((@bool.axiom_match_bool_type_false) (return)) (case_true)) (case_false)).
theorem bool.sym_eq_match_bool_type_true : forall (return : Type) , forall (case_true:return) , forall (case_false:return) , (((leibniz.leibniz) (return)) (case_true)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.true) )) := fun (return : Type) , fun (case_true : return) , fun (case_false : return) , ((((@leibniz.sym_leibniz) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.true) ))) (case_true)) ((((@bool.eq_match_bool_type_true) (return)) (case_true)) (case_false)).
theorem bool.sym_eq_match_bool_type_false : forall (return : Type) , forall (case_true:return) , forall (case_false:return) , (((leibniz.leibniz) (return)) (case_false)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.false) )) := fun (return : Type) , fun (case_true : return) , fun (case_false : return) , ((((@leibniz.sym_leibniz) (return)) (((((bool.match_bool_type) (return)) (case_true)) (case_false)) ((bool.false) ))) (case_false)) ((((@bool.eq_match_bool_type_false) (return)) (case_true)) (case_false)).
noncomputable def bool.andb : (bool.bool) -> (bool.bool) -> bool.bool := fun (b1 : bool.bool) , fun (b2 : bool.bool) , ((((bool.match_bool_type) (bool.bool)) (b2)) ((bool.false) )) (b1).
theorem bool.andb_true_r : forall (b1:bool.bool) , forall (b2:bool.bool) , ((((logic.eq_) (bool.bool)) ((((bool.andb) ) (b1)) (b2))) ((bool.true) )) -> (((logic.eq_) (bool.bool)) (b2)) ((bool.true) ) := fun (b1 : bool.bool) , fun (b2 : bool.bool) , ((((@bool.match_bool_prop) (fun (__ : bool.bool) , ((((logic.eq_) (bool.bool)) ((((bool.andb) ) (__)) (b2))) ((bool.true) )) -> (((logic.eq_) (bool.bool)) (b2)) ((bool.true) ))) ((((((@bool.sym_eq_match_bool_type_true) (bool.bool)) (b2)) ((bool.false) )) (fun (x : bool.bool) , ((((logic.eq_) (bool.bool)) (x)) ((bool.true) )) -> (((logic.eq_) (bool.bool)) (b2)) ((bool.true) ))) (fun (auto : (((logic.eq_) (bool.bool)) (b2)) ((bool.true) )) , (((((((@logic.rewrite_l) (bool.bool)) (b2)) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (b2)) (__))) (((@logic.refl_) (bool.bool)) (b2))) ((bool.true) )) (auto))))) ((((((@bool.sym_eq_match_bool_type_false) (bool.bool)) (b2)) ((bool.false) )) (fun (x : bool.bool) , ((((logic.eq_) (bool.bool)) (x)) ((bool.true) )) -> (((logic.eq_) (bool.bool)) (b2)) ((bool.true) ))) (((((@bool.match_bool_prop) (fun (__ : bool.bool) , ((((logic.eq_) (bool.bool)) ((bool.false) )) ((bool.true) )) -> (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (fun (auto : (((logic.eq_) (bool.bool)) ((bool.false) )) ((bool.true) )) , (((@logic.refl_) (bool.bool)) ((bool.true) )))) (fun (auto : (((logic.eq_) (bool.bool)) ((bool.false) )) ((bool.true) )) , (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((bool.false) )) (auto)))) (b2)))) (b1).
